window.WhatsApp ?= {}
window.WhatsApp.App = class App
  constructor: ->
    @chatWindows = {}

    @contactsWindow = new WhatsApp.ContactsWindow this

    if phone = localStorage.getItem 'phone'
      $('.login input[name=phone]').val phone

    if imei = localStorage.getItem 'imei'
      $('.login input[name=imei]').val imei

    if name = localStorage.getItem 'name'
      $('.login input[name=name]').val name

    @handleForm()

  handleForm: =>
    $('.login form').submit (e) =>
      e.preventDefault()

      $('.login .form').fadeOut 'fast', =>
        $('.login .loading').fadeIn 'fast'

      phone = $('.login input[name=phone]').val()
      imei  = $('.login input[name=imei]').val()
      name  = $('.login input[name=name]').val()

      if $('.login form #remember').is(':checked')
        localStorage.setItem 'phone', phone
        localStorage.setItem 'imei', imei
        localStorage.setItem 'name', name

      unless @socket?
        @socket = io.connect "http://#{window.location.hostname}:3888/"

        @socket.on 'disconnect', =>
          alert 'Connection to the server has been lost. Please login again.'
          location.reload()

      auth = =>
        @socket.emit 'auth', phone, imei, name, (success, err) =>
          if success
            $('.login').fadeOut 'fast', =>
              $('.chat').fadeIn 'fast'

            $('.chat .logout').click =>
              if confirm 'Would you really like to sign out?'
                location.reload()

            @contactsWindow.show()          

            @listenForMessages()
          else
            $('.login .loading').fadeOut 'fast', =>
              $('.login .form').fadeIn 'fast'

              $('.login .error').text(err).show()

      if @socket?
        auth()
      else
        @socket.on 'connect', =>
          auth()
        

  listenForMessages: ->
    @socket.on 'error', (err) =>
      if err.match /Replaced/
        alert "Connection has been closed due to a conflict. Please turn off WhatsApp on your phone to avoid being kicked out."
        location.reload()
      else
        alert "Error: " + err
        location.reload()

    @socket.on 'wa_message', (message) =>
      unless @chatWindows.hasOwnProperty message.from
        window = new WhatsApp.ChatWindow this, message.from, message.fromUsername
        window.receiveMessage message

        @chatWindows[message.from] = window
      else
        window = @chatWindows[message.from]
        window.receiveMessage message
        window.show()

      @contactsWindow.recognizeContact message.fromUsername, message.from

  sendMessage: (to, message) ->
    @socket.emit 'wa_message', { to: to, message: message }

  openWindow: (contactName, contactHandle) ->
    if @chatWindows.hasOwnProperty(contactName)
        return @chatWindows[contactName].show()

    if @chatWindows.hasOwnProperty(contactHandle)
       return @chatWindows[contactHandle].show()

    window = new WhatsApp.ChatWindow this, contactHandle, contactName
    @chatWindows[contactHandle] = window
    window.show()

    @contactsWindow.recognizeContact contactName, contactHandle

