window.WhatsApp ?= {}
window.WhatsApp.ContactsWindow = class ContactsWindow extends EventEmitter
  constructor: (@app) ->
    @window = $('<div>').addClass('window contacts').attr('data-id': @from).appendTo $('.chat')
    @headline = $('<div>').addClass('headline').appendTo(@window).text 'Chats'

    @contactsList = $('<ul>').addClass('contacts').appendTo @window

    @handleDrag()

    @toolbar = $('<ul>').addClass('toolbar').appendTo @window

    @toolbarAddItem = $('<li>').addClass('add').appendTo @toolbar

    @toolbarAddItem.click => @toolbarAdd()

    @contacts = {}

  toolbarAdd: ->
    if number = prompt 'Please enter a mobile number with country code (but without + or 00)'
      @app.openWindow number, number + '@s.whatsapp.net'

  recognizeContact: (contactName, contactHandle) ->
    unless @contacts.hasOwnProperty(contactHandle)
      contactRow = @addContactRow contactName, contactHandle

      @contacts[contactHandle] = contactRow
    else
      contactRow = @contacts[contactHandle]

      contactRow.find('.name').text contactName

  addContactRow: (contactName, contactHandle) ->
    contactLi = $('<li>').addClass('contact').appendTo @contactsList
    contactNameDiv = $('<div>').addClass('name').text(contactName).appendTo contactLi
    contactHandleDiv = $('<div>').addClass('handle').text(contactHandle).appendTo contactLi

    contactLi.click =>
      @app.openWindow contactName, contactHandle

    return contactLi


  handleDrag: ->
    @headline.mousedown (e) =>
      e.preventDefault()

      @bringToFront()

      lastX = e.pageX
      lastY = e.pageY

      $(document).mousemove (e) =>
        diffX = e.pageX - lastX
        diffY = e.pageY - lastY

        @window.css
          left: @window.position().left + diffX
          top: @window.position().top + diffY

        lastX = e.pageX
        lastY = e.pageY

        $(document).mouseup (e) =>
          $(document).off 'mousemove'

  bringToFront: ->
    maxZ = 0
    for el in $('.chat > *')
      if $(el).css('z-index') and $(el).css('z-index') isnt 'auto'
        maxZ = Math.max(parseInt($(el).css('z-index')), maxZ)

    newZ = maxZ + 1
    @window.css zIndex: newZ


  show: ->
    @window.fadeIn 'fast'