{EventEmitter} = require 'events'

WhatsProt      = require './whatsapp/whatsprot'
request        = require 'request'
fs             = require 'fs'

module.exports = class WhatsappSocket extends EventEmitter
  constructor: (@socket) ->
    @socket.on 'auth', @onAuth

    @socket.emit 'request_auth'

  onAuth: (phone, imei, name, callback) =>
    @prot = new WhatsProt phone, imei, name, true

    countrycode = phone.substr 0, 2
    number      = phone.substr 2

    url = 'https://r.whatsapp.net/v1/exist.php?cc=' + countrycode + '&in=' + number + '&udid=' + @prot.encryptPassword()
    request.get url, (e, r, body) =>
      if body.match /status="ok"/i
        @prot.on 'connected', =>
          @prot.login (success, err) => 
            @listenForEvents()
            callback success, err

        @prot.on 'disconnect', =>
          @socket.disconnect()

        @prot.connect()
      else
        callback false, "This number is not registered with the given device identifier."

  listenForEvents: ->    
    @prot.on 'wa_message', (message) =>
      @socket.emit 'wa_message', message

    @socket.on 'wa_message', (message) =>
      group = false
      if ~message.to.indexOf('@')
        split = message.to.split("@")
        message.to = split[0]
        if split[1] is 'g.us'
          group = true

      @prot.message +new Date() + '-1', message.to, message.message, group

    @prot.on 'error', (error) =>
      @socket.emit 'error', error

    @socket.on 'disconnect', =>
      @prot.close()