(function() {
  var App, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  if ((_ref = window.WhatsApp) == null) {
    window.WhatsApp = {};
  }

  window.WhatsApp.App = App = (function() {

    function App() {
      this.handleForm = __bind(this.handleForm, this);

      var imei, name, phone;
      this.chatWindows = {};
      this.contactsWindow = new WhatsApp.ContactsWindow(this);
      if (phone = localStorage.getItem('phone')) {
        $('.login input[name=phone]').val(phone);
      }
      if (imei = localStorage.getItem('imei')) {
        $('.login input[name=imei]').val(imei);
      }
      if (name = localStorage.getItem('name')) {
        $('.login input[name=name]').val(name);
      }
      this.handleForm();
    }

    App.prototype.handleForm = function() {
      var _this = this;
      return $('.login form').submit(function(e) {
        var auth, imei, name, phone;
        e.preventDefault();
        $('.login .form').fadeOut('fast', function() {
          return $('.login .loading').fadeIn('fast');
        });
        phone = $('.login input[name=phone]').val();
        imei = $('.login input[name=imei]').val();
        name = $('.login input[name=name]').val();
        if ($('.login form #remember').is(':checked')) {
          localStorage.setItem('phone', phone);
          localStorage.setItem('imei', imei);
          localStorage.setItem('name', name);
        }
        if (_this.socket == null) {
          _this.socket = io.connect("http://" + window.location.hostname + ":3888/");
          _this.socket.on('disconnect', function() {
            alert('Connection to the server has been lost. Please login again.');
            return location.reload();
          });
        }
        auth = function() {
          return _this.socket.emit('auth', phone, imei, name, function(success, err) {
            if (success) {
              $('.login').fadeOut('fast', function() {
                return $('.chat').fadeIn('fast');
              });
              $('.chat .logout').click(function() {
                if (confirm('Would you really like to sign out?')) {
                  return location.reload();
                }
              });
              _this.contactsWindow.show();
              return _this.listenForMessages();
            } else {
              return $('.login .loading').fadeOut('fast', function() {
                $('.login .form').fadeIn('fast');
                return $('.login .error').text(err).show();
              });
            }
          });
        };
        if (_this.socket != null) {
          return auth();
        } else {
          return _this.socket.on('connect', function() {
            return auth();
          });
        }
      });
    };

    App.prototype.listenForMessages = function() {
      var _this = this;
      this.socket.on('error', function(err) {
        if (err.match(/Replaced/)) {
          alert("Connection has been closed due to a conflict. Please turn off WhatsApp on your phone to avoid being kicked out.");
          return location.reload();
        } else {
          alert("Error: " + err);
          return location.reload();
        }
      });
      return this.socket.on('wa_message', function(message) {
        var window;
        if (!_this.chatWindows.hasOwnProperty(message.from)) {
          window = new WhatsApp.ChatWindow(_this, message.from, message.fromUsername);
          window.receiveMessage(message);
          _this.chatWindows[message.from] = window;
        } else {
          window = _this.chatWindows[message.from];
          window.receiveMessage(message);
          window.show();
        }
        return _this.contactsWindow.recognizeContact(message.fromUsername, message.from);
      });
    };

    App.prototype.sendMessage = function(to, message) {
      return this.socket.emit('wa_message', {
        to: to,
        message: message
      });
    };

    App.prototype.openWindow = function(contactName, contactHandle) {
      var window;
      if (this.chatWindows.hasOwnProperty(contactName)) {
        return this.chatWindows[contactName].show();
      }
      if (this.chatWindows.hasOwnProperty(contactHandle)) {
        return this.chatWindows[contactHandle].show();
      }
      window = new WhatsApp.ChatWindow(this, contactHandle, contactName);
      this.chatWindows[contactHandle] = window;
      window.show();
      return this.contactsWindow.recognizeContact(contactName, contactHandle);
    };

    return App;

  })();

}).call(this);
