(function() {
  var ContactsWindow, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  if ((_ref = window.WhatsApp) == null) {
    window.WhatsApp = {};
  }

  window.WhatsApp.ContactsWindow = ContactsWindow = (function(_super) {

    __extends(ContactsWindow, _super);

    function ContactsWindow(app) {
      var _this = this;
      this.app = app;
      this.window = $('<div>').addClass('window contacts').attr({
        'data-id': this.from
      }).appendTo($('.chat'));
      this.headline = $('<div>').addClass('headline').appendTo(this.window).text('Chats');
      this.contactsList = $('<ul>').addClass('contacts').appendTo(this.window);
      this.handleDrag();
      this.toolbar = $('<ul>').addClass('toolbar').appendTo(this.window);
      this.toolbarAddItem = $('<li>').addClass('add').appendTo(this.toolbar);
      this.toolbarAddItem.click(function() {
        return _this.toolbarAdd();
      });
      this.contacts = {};
    }

    ContactsWindow.prototype.toolbarAdd = function() {
      var number;
      if (number = prompt('Please enter a mobile number with country code (but without + or 00)')) {
        return this.app.openWindow(number, number + '@s.whatsapp.net');
      }
    };

    ContactsWindow.prototype.recognizeContact = function(contactName, contactHandle) {
      var contactRow;
      if (!this.contacts.hasOwnProperty(contactHandle)) {
        contactRow = this.addContactRow(contactName, contactHandle);
        return this.contacts[contactHandle] = contactRow;
      } else {
        contactRow = this.contacts[contactHandle];
        return contactRow.find('.name').text(contactName);
      }
    };

    ContactsWindow.prototype.addContactRow = function(contactName, contactHandle) {
      var contactHandleDiv, contactLi, contactNameDiv,
        _this = this;
      contactLi = $('<li>').addClass('contact').appendTo(this.contactsList);
      contactNameDiv = $('<div>').addClass('name').text(contactName).appendTo(contactLi);
      contactHandleDiv = $('<div>').addClass('handle').text(contactHandle).appendTo(contactLi);
      contactLi.click(function() {
        return _this.app.openWindow(contactName, contactHandle);
      });
      return contactLi;
    };

    ContactsWindow.prototype.handleDrag = function() {
      var _this = this;
      return this.headline.mousedown(function(e) {
        var lastX, lastY;
        e.preventDefault();
        _this.bringToFront();
        lastX = e.pageX;
        lastY = e.pageY;
        return $(document).mousemove(function(e) {
          var diffX, diffY;
          diffX = e.pageX - lastX;
          diffY = e.pageY - lastY;
          _this.window.css({
            left: _this.window.position().left + diffX,
            top: _this.window.position().top + diffY
          });
          lastX = e.pageX;
          lastY = e.pageY;
          return $(document).mouseup(function(e) {
            return $(document).off('mousemove');
          });
        });
      });
    };

    ContactsWindow.prototype.bringToFront = function() {
      var el, maxZ, newZ, _i, _len, _ref1;
      maxZ = 0;
      _ref1 = $('.chat > *');
      for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
        el = _ref1[_i];
        if ($(el).css('z-index') && $(el).css('z-index') !== 'auto') {
          maxZ = Math.max(parseInt($(el).css('z-index')), maxZ);
        }
      }
      newZ = maxZ + 1;
      return this.window.css({
        zIndex: newZ
      });
    };

    ContactsWindow.prototype.show = function() {
      return this.window.fadeIn('fast');
    };

    return ContactsWindow;

  })(EventEmitter);

}).call(this);
